package metaobj;

import java.util.List;
import meta.AnnotationArgumentsKind;
import meta.AttachedDeclarationKind;
import meta.CyanMetaobject;
import meta.CyanMetaobjectLiteralObject;
import meta.CyanMetaobjectWithAt;
import meta.IAction_dsa;
import meta.ICompiler_dsa;
import meta.WrCyanMetaobjectWithAtAnnotation;
import meta.WrEnv;
import meta.WrMethodDec;
import meta.WrProgramUnit;

public class CyanMetaobjectFour extends CyanMetaobjectWithAt
		implements IAction_dsa {

	public CyanMetaobjectFour() {
		super("four", AnnotationArgumentsKind.OneParameter,
				new AttachedDeclarationKind[] {
						AttachedDeclarationKind.NONE_DEC
		});
	}


	@Override
	public String getPackageOfType() { return "cyan.lang"; }
	/**
	 * If the metaobject annotation has type <code>packageName.prototypeName</code>, this method returns
	 * <code>prototypeName</code>.  See {@link CyanMetaobjectLiteralObject#getPackageOfType()}
	   @return
	 */

	@Override
	public String getPrototypeOfType() {
		return "Int";
	}

	@Override
	public boolean isExpression() {
		return true;
	}

	@Override
	public StringBuffer dsa_codeToAdd(ICompiler_dsa compiler_dsa) {

		int value = 0;
		WrEnv env = compiler_dsa.getEnv();
		WrProgramUnit pu = env.getCurrentProgramUnit();
		WrMethodDec currentMethod = env.getCurrentMethod();

		WrCyanMetaobjectWithAtAnnotation annot = this.getMetaobjectAnnotation();
		List<Object> paramList = annot.getJavaParameterList();
		Object obj = paramList.get(0);

		if ( !(obj instanceof String) ) {
			this.addError("The parameter to this annotation should be a string");
		}
		String s = (String ) obj;
		s = CyanMetaobject.removeQuotes(s);
		switch ( s ) {
		case "method":
			value = pu.getMethodDecList(env).size();
			break;
		case "field":
			value = pu.getFieldList(env).size();
			break;
		case "statement":
			value = currentMethod.getStatementList(env).getStatementList().size();
			break;
		case "parameter":
			value = currentMethod.getMethodSignature().getParameterList().size();
			break;
		case "interface":
			value = pu.getInterfaceList(env).size();
			break;
		default:
			this.addError("Illegal parameter: '" + s + "'" );
		}
		return new StringBuffer("" + value);
	}


}

