package metaobj;

import java.util.List;
import meta.AnnotationArgumentsKind;
import meta.AttachedDeclarationKind;
import meta.CyanMetaobject;
import meta.CyanMetaobjectWithAt;
import meta.IAction_afti;
import meta.ICheckDeclaration_afsa;
import meta.ICompiler_afti;
import meta.ICompiler_dsa;
import meta.IDeclaration;
import meta.ISlotInterface;
import meta.Tuple2;
import meta.WrASTVisitor;
import meta.WrCyanMetaobjectAnnotation;
import meta.WrCyanMetaobjectWithAtAnnotation;
import meta.WrEnv;
import meta.WrMethodDec;
import meta.WrProgramUnit;
import meta.WrStatementBreak;
import meta.WrStatementRepeat;
import meta.WrStatementWhile;

public class CyanMetaobjectOne extends CyanMetaobjectWithAt
implements IAction_afti, ICheckDeclaration_afsa {

	public CyanMetaobjectOne() {
		super("one", AnnotationArgumentsKind.ZeroOrMoreParameters,
				new AttachedDeclarationKind[] {
				AttachedDeclarationKind.PROTOTYPE_DEC
		});
	}

	@Override
	public Tuple2<StringBuffer, String> afti_codeToAdd(
			ICompiler_afti compiler,
			List<Tuple2<WrCyanMetaobjectAnnotation,
			List<ISlotInterface>>> infoList) {


		IDeclaration dec = this.getAttachedDeclaration();
		WrProgramUnit pu = (WrProgramUnit ) dec;
		WrEnv environment = compiler.getEnv();
		WrCyanMetaobjectWithAtAnnotation annot =
				this.getMetaobjectAnnotation();
		for ( Object obj : annot.getJavaParameterList() ) {
			if ( obj instanceof Integer ) {

			}
		}

		return new Tuple2<StringBuffer, String>(
				new StringBuffer("var Int count = 0;"),
				"var Int count");
	}

	@Override
	public void afsa_checkDeclaration(ICompiler_dsa compiler) {

		IDeclaration dec = this.getAttachedDeclaration();
		WrProgramUnit pu = (WrProgramUnit ) dec;
		WrEnv env = compiler.getEnv();
		WrCyanMetaobjectWithAtAnnotation annot =
				this.getMetaobjectAnnotation();
		List<Object> paramList = annot.getJavaParameterList();
		//char []textDSL = annot.getTextAttachedDSL();
//		String p2 = (String ) paramList.get(1);
//		String p2_wo_Quotes = CyanMetaobject.removeQuotes(p2);
//		WrCompilationUnit compUnit = env.getCurrentCompilationUnit();
//		char []text = compUnit.getOriginalText();
//		WrSymbol []symbolList = compUnit.getSymbolList();
//		int sizeSymbolList = compUnit.getSizeSymbolList();
//
//		for (int i = 0; i < sizeSymbolList; ++i) {
//			System.out.print(symbolList[i] + " ");
//		}
//
//
//		env.getCurrentMethod();
//		env.getCurrentProgramUnit();

		for ( Object obj : paramList ) {
			if ( obj instanceof Integer ) {
				System.out.print("parameter is an Int: " + obj);
			}
			else if ( obj instanceof String ) {
				String s = (String ) obj;
				String sWithoutQuotes = CyanMetaobject.removeQuotes(s);
				if ( !s.equals(sWithoutQuotes) ) {
					System.out.print("parameter is string, it was given with quotes: " +
				        sWithoutQuotes);
				}
				else {
					System.out.println("parameter is an identifer: " + s);
				}

			}
			else if ( obj instanceof Object[] ) {
				/*
				 * literal arrays and tuples are all converted to a Java array
				 * of type Object []
				 *
				 */
				Object []array = (Object []) obj;
				System.out.print(" [ ");
				int size = array.length;
				for (Object elem : array ) {
					System.out.print(elem);
					if ( --size > 0 ) System.out.print(", ");
				}
				System.out.println(" ] ");
			}
		}

//		this.addError("This is the error message");
//		this.addError(annot.getFirstSymbol(), "This is the error message");
//		this.addError(pu.getFirstSymbol(env), "This is the error message");
//		this.addError(pu.getMethodDecList(env).get(0).getFirstSymbol(env),
//				"This is the error message");

		CyanMetaobjectWithAt metaobject = this;
	    cyanruntime.Ref<Integer> breakCount = new cyanruntime.Ref<>();
	    breakCount.elem = 0;

		pu.accept( new WrASTVisitor() {
	    	@Override
			public void visit(WrStatementBreak node, WrEnv env2) {
	    		++breakCount.elem;
	    		metaobject.addError(node.getFirstSymbol(),
	    				"'break' are not allowed in prototype "
	    				+ pu.getFullName());
			}

		}, env);


		MyASTVisitor visitor = new MyASTVisitor();
		pu.accept(visitor, env);
		if ( visitor.ifCount > 3 ) {
			this.addError("This prototype should not have more than 2 'if' statements");
		}

		pu.accept( new WrASTVisitor() {
	    	@Override
			public void visit(WrMethodDec node, WrEnv env2) {
	    		System.out.println(node.getName());
			}

		}, env);



		if ( pu.getMethodDecList(env).size() > 0 ) {
			pu.getMethodDecList(env).get(0).accept(
			    new WrASTVisitor() {
			    	@Override
					public void visit(WrStatementRepeat node, WrEnv env2) {
			    		metaobject.addError(node.getFirstSymbol(),
						  "'repeat-until' statements are not allowed in "
						  + "the first method");
					}

				}, env);

		}
	}


}

class MyASTVisitor extends WrASTVisitor {
	public CyanMetaobjectWithAt metaobject;
	public int ifCount = 0;
	public int whileCount = 0;

	@Override
	public void visit(WrStatementWhile node, WrEnv env) {
		metaobject.addError(node.getFirstSymbol(), "'while' statements are not allowed");
	}
}